<?php
/* eyeHostOs [slan.fr] version 0.1
* par Jrme Lalouette
* 1. formulaire d'enregistrement pour le service
* 2. cration de la racine de destination
* 3. copie de la racine source comportant l'install de la dernire version de EyeOs
* 4. redirection vers le module d'installation de eyeOS
*/                               
$script_version .= "eyehOSt v03";

function randomizer( $nb_car ) {
	
	$string = "";
	$chaine = "abcdefghijklmnpqrstuvwxyzABCDEFGHIJKLMONOPQRSTUVWXYZ";
	srand( ( double ) microtime()*1000000 );
	
  for( $i=0 ; $i < $nb_car; $i++ ) {
		$string .= $chaine[rand()%strlen( $chaine )];
	}
	return $string;
}

/* 
==> YYYYMMDDHHMMSS+16ALPHA 
*/
function idGenerator ( ) {
	
	$tring .= date( "Ymdhis" );
	$tring .= randomizer( 16 );
  return $tring;
	
}

function create_rep ( $rep_name ){
  
  if (!is_dir( $rep_name ) ) {
    mkdir( './'.$rep_name ); 
  }else{
    return FALSE;
  }
}
function create_tab ($dir) { // fonction creant le tableau contenant les repertoires et fichiers
    $dir = rtrim ($dir, '/'); // on vire un eventuel slash mis par l'utilisateur de la fonction a droite du repertoire
		if (is_dir ($dir)) // si c'est un repertoire
			$dh = opendir ($dir); // on l'ouvre
		else {
			echo $dir, ' n\'est pas un repertoire valide'; // sinon on sort! Appel de fonction non valide
			exit;
			}
		while (($file = readdir ($dh)) !== false ) { //boucle pour parcourir le repertoire 
			if ($file !== '.' && $file !== '..') { // no comment
				$path =$dir.'/'.$file; // construction d'un joli chemin...
				if (is_dir ($path)) { //si on tombe sur un sous-repertoire 
					$tableau[$dir]['dir'][] = $path;
					$tabTmp = create_tab ($path); // appel recursif pour lire a l'interieur de ce sous-repertoire
					if (is_array ($tabTmp) && is_array ($tableau))
						$tableau = array_merge ($tableau, $tabTmp);
				}
				else
					$tableau[$dir]['file'][] = $path;
			}
		}
		closedir ($dh); // on ferme le repertoire courant
		if (isset ($tableau)) {
            return $tableau;
        }
	}

function copier_rep ($destination, $reps, $tableau_dir = array ()) { 
		if (empty ($tableau_dir)) {
			//echo 'Entre';
			$tableau_dir = create_tab ($reps);
		}
		if (!is_array ($reps)) {
			$reps = array ($reps);
		}
		foreach ($reps as $rep) {
			if (!is_dir ($destination.'/'.basename ($rep))) {
				mkdir ($destination.'/'.basename ($rep));
				if (!empty ($tableau_dir[$rep]['file']) && isset($tableau_dir[$rep]['file']) && is_array ($tableau_dir[$rep]['file'])) {
					foreach ($tableau_dir[$rep]['file'] as $fichier) {
						copy ($fichier, $destination.'/'.basename ($rep).'/'.basename ($fichier));
					}
				}
				if (!empty ($tableau_dir[$rep]['dir']) && isset ($tableau_dir[$rep]['dir']) && is_array ($tableau_dir[$rep]['dir'])) {
					copier_rep ($destination.'/'.basename ($rep), $tableau_dir[$rep]['dir'], $tableau_dir);
				}
			}
		}
	}

?>
